#include <conio.h>
#include <io.h>
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>
#include <allegro.h>
#include "edop.h"
#include "ymw.h"
#include "Import.h"
#include "find.h"
#include "mem.h"
#include "lists.h"

/* The values for rooms positions that havn't been set by the
 * door routine yet.  Room Not Defined
 ***/
#define RNDX            0
#define RNDY            0
#define RNDZ            -5

/* This REALLY needs to be variable...
 ***/
//#define VNM             100
int VNM = 100;

/* We really shouldn't rely on the MainDialog for this... */
int oppdir( int dir );

unsigned long long scan_bv( char *buf )
{
    unsigned long long ret = 0;
    unsigned int j;

    if( buf[0] >= '0' && buf[0] <= '9' ){
      sscanf( buf, "%llu", &ret );
      }
    else{
      for( j = 0; j < strlen(buf); j++ ){
         ret |= (1<<(buf[0]-'a'+1));
         }
      }

    return ret;
}

void get_term_str( FILE *fh, char *buf, char term, int max )
{
    int j=0;
    char mbuf;

    for( j = 0; j < max; j++ ){
       fscanf( fh, "%c", &mbuf );
       if( mbuf == term ) return;
       if( mbuf == '\n' ){
         buf[j] = ' ';
         }
       else{
         buf[j] = mbuf;
         }
       }

    fprintf( stderr, "get_term_str:  Reached max on read, %d\n", max );

    for( ; mbuf != '~'; )
       fscanf( fh, "%c", &mbuf );

    return;
}

int anx=0, any=0, anz=0;

int import_circle_wld( WORLD *world, char *file )
{
    FILE *fh;
    char buf[80];
    int j=0, k, tmp_i;
    int zone, room, door;

    if( (fh = fopen( file, "rt" )) == NULL ){
      fprintf( stderr, "import_circle_wld:  Error opening file #%d, %s.\n", j, file );
      return -1;
      }

    printf("Loading from world file ``%s\'\'...\n", file );

    sscanf( get_filename( file ), "%d.wld", &tmp_i );
    if( (zone = ifind_zone_vnum_world( world, tmp_i )) < 0 ){
      zone = add_zone( world );
      world->zone[zone].vnum = tmp_i;
      }

    room = -1;
    for( k = 0;; k++ ){
       fscanf( fh, "%s\n", buf );
       switch( buf[0] ){
         case '#':  /* It's a room */
              sscanf( buf, "#%d\n", &tmp_i );
              room = add_room( &world->zone[zone], RNDX, RNDY, RNDZ );

              world->zone[zone].room[room].vnum = tmp_i-(world->zone[zone].vnum*VNM);
  
              get_term_str( fh, world->zone[zone].room[room].title, '~', NAMESIZE );
              fscanf( fh, "\n");
              get_term_str( fh, world->zone[zone].room[room].desc, '~', RDSIZE );
              fscanf( fh, "\n");
  
              fscanf( fh, "%d %s %d\n", &tmp_i, buf, &tmp_i );
              world->zone[zone].room[room].rbv = scan_bv( buf );
              world->zone[zone].room[room].stype = tmp_i;
              break;

         case 'D':  /* It's a door */
              if( room < 0 ){
                fprintf( stderr, "import_circle_wld:  Door def without room...\n");
                return -1;
                }
              sscanf( buf, "D%d\n", &tmp_i );

              door = add_hanging_door( &world->zone[zone].room[room], tmp_i );

              if( zone == 0 && room == 7 && door == 3 ){
                tmp_i = zone;
                }

              get_term_str( fh, world->zone[zone].room[room].door[door].desc, '~', RDSIZE );
              fscanf( fh, "\n");
              get_term_str( fh, world->zone[zone].room[room].door[door].keywords, '~', NAMESIZE );
              fscanf( fh, "\n");

              fscanf( fh, "%hi %d %d\n",
                          &world->zone[zone].room[room].door[door].typea,
                          &world->zone[zone].room[room].door[door].key,
                          &tmp_i );
              world->zone[zone].room[room].door[door].czone = tmp_i/VNM;
              world->zone[zone].room[room].door[door].croom = tmp_i-(tmp_i/VNM)*VNM;
              if( world->zone[zone].room[room].door[door].key > -1 ){
                if( world->zone[zone].room[room].door[door].key/VNM != world->zone[zone].vnum ){
                  fprintf( stderr, "import_circle_wld:  Door has key in different zone, setting to none.\n");
                  world->zone[zone].room[room].door[door].key = -1;
                  }
                else{
                  world->zone[zone].room[room].door[door].key = world->zone[zone].room[room].door[door].key-(world->zone[zone].room[room].door[door].key/VNM)*VNM;
                  }
                }
              break;

         case 'E':  /* It's an exd */
              if( room < 0 ){
                fprintf( stderr, "import_circle_wld:  Exd def without room...\n");
                return -1;
                }
              tmp_i = add_room_exd( &world->zone[zone].room[room] );
              get_term_str( fh, world->zone[zone].room[room].exd[tmp_i].keywords, '~', NAMESIZE );
              fscanf( fh, "\n");
              get_term_str( fh, world->zone[zone].room[room].exd[tmp_i].desc, '~', RDSIZE );
              fscanf( fh, "\n");
              break;

         case 'S':  /* End of a room */
              room = -1;
              break;

         case '$':  /* Game over... */
              fclose( fh );
              fh = NULL;
              break;

         default:   /* Error!!! */
              fprintf( stderr, "import_circle_wld:  Expecting #, $, D, or E and got `%c\'\n", buf[0] );
              fclose( fh );
              fh = NULL;
              return -1;
              break;
         }
      if( !fh ) break;
      }
    fclose( fh );

    return j;
}

int import_circle_resolve_doors( WORLD *world )
{
    int j=0, k, l;
    int czone, croom, cdoor;
    int num_set_t, num_set_c, last_num_set_c, total=0;

    for( j = 0; j < world->num_zones; j++ ){
       for( k = 0; k < world->zone[j].num_rooms; k++ ){
          total++;
          for( l = 0; l < world->zone[j].room[k].num_doors; l++ ){
             if( !world->zone[j].room[k].door[l].other ){
               czone = ifind_zone_vnum_world( world, world->zone[j].room[k].door[l].czone );
               if( czone >= world->num_zones || czone < 0 ){
                 fprintf( stderr, "import_circle_resolve_doors:  Unknown czone in asignment\n\t[%d], [%d,%d,%d]->[%d,%d,%d]\n", world->zone[j].room[k].door[l].czone, j, k, l, world->zone[j].vnum, world->zone[j].room[j].vnum, world->zone[j].room[k].door[l].dir );
                 exit(0);
                 }
               croom = ifind_room_vnum_zone( &world->zone[czone], world->zone[j].room[k].door[l].croom );
               if( croom >= world->zone[czone].num_rooms || croom < 0 ){
                 fprintf( stderr, "import_circle_resolve_doors:  Unknown croom in asignment\n\t[%d,%d], [%d,%d,%d]->[%d,%d,%d]\n", world->zone[j].room[k].door[l].czone, world->zone[j].room[k].door[l].croom, j, k, l, world->zone[j].vnum, world->zone[j].room[j].vnum, world->zone[j].room[k].door[l].dir );
                 del_door( &world->zone[j].room[k], l );
                 l--;
                 continue;
//                 return -1;
                 }
               if( !(world->zone[j].room[k].door[l].other = find_door_croom_room( &world->zone[czone].room[croom], world->zone[j].vnum, world->zone[j].room[k].vnum ))){
                 /* One-way door, make up the other end on our own */
                 cdoor = add_hanging_door( &world->zone[czone].room[croom], oppdir( world->zone[j].room[k].door[l].dir ) );
                 world->zone[j].room[k].door[l].cdir = oppdir( world->zone[j].room[k].door[l].dir );
                 world->zone[j].room[k].door[l].other = &world->zone[czone].room[croom].door[cdoor];
                 world->zone[czone].room[croom].door[cdoor].other = &world->zone[j].room[k].door[l];
                 world->zone[czone].room[croom].door[cdoor].czone = world->zone[j].vnum;
                 world->zone[czone].room[croom].door[cdoor].croom = world->zone[j].room[k].vnum;
                 world->zone[czone].room[croom].door[cdoor].cdir = world->zone[j].room[k].door[l].dir;
                 world->zone[czone].room[croom].door[cdoor].typeb |= D_CANT_LEAVE;
                 }
               else{
                 world->zone[j].room[k].door[l].cdir = world->zone[j].room[k].door[l].other->dir;
                 world->zone[j].room[k].door[l].other->cdir = world->zone[j].room[k].door[l].dir;
                 }
               }
             }
          }
       }

    rehash_world( world );

    num_set_t = 0;
    num_set_c = 0;
    last_num_set_c = -1; /* Just non-zero */
    world->zone[0].room[0].x = 0;
    world->zone[0].room[0].y = 0;
    world->zone[0].room[0].z = 0;
    do{
      for( j = 0; j < world->num_zones; j++ ){
         for( k = 0; k < world->zone[j].num_rooms; k++ ){
            for( l = 0; l < world->zone[j].room[k].num_doors; l++ ){
/*               if( world->zone[j].room[k].x == RNDX &&
                   world->zone[j].room[k].y == RNDY &&
                   world->zone[j].room[k].z == RNDZ &&
                   last_num_set_c == 0 ){
                 world->zone[j].room[k].x = 0;
                 world->zone[j].room[k].y = 0;
                 world->zone[j].room[k].z = 0;
                 num_set_c = 1;
                 num_set_t++;
                 goto lkes;
                 }*/
               if( world->zone[j].room[k].door[l].other ){
                 world->zone[j].room[k].door[l].cdir = world->zone[j].room[k].door[l].other->dir;
                 world->zone[j].room[k].door[l].other->cdir = world->zone[j].room[k].door[l].dir;
                 world->zone[j].room[k].door[l].other->other = &world->zone[j].room[k].door[l];
                 if( world->zone[j].room[k].door[l].other->parent->x == RNDX &&
                     world->zone[j].room[k].door[l].other->parent->y == RNDY &&
                     world->zone[j].room[k].door[l].other->parent->z == RNDZ ){
                   num_set_c++;
                   num_set_t++;
                   switch( world->zone[j].room[k].door[l].dir ){
                     case D_NORTH:
                          world->zone[j].room[k].door[l].other->parent->x = world->zone[j].room[k].x;
                          world->zone[j].room[k].door[l].other->parent->y = world->zone[j].room[k].y-1;
                          world->zone[j].room[k].door[l].other->parent->z = world->zone[j].room[k].z;
                          break;
   
                     case D_SOUTH:
                          world->zone[j].room[k].door[l].other->parent->x = world->zone[j].room[k].x;
                          world->zone[j].room[k].door[l].other->parent->y = world->zone[j].room[k].y+1;
                          world->zone[j].room[k].door[l].other->parent->z = world->zone[j].room[k].z;
                          break;
   
                     case D_EAST:
                          world->zone[j].room[k].door[l].other->parent->x = world->zone[j].room[k].x+1;
                          world->zone[j].room[k].door[l].other->parent->y = world->zone[j].room[k].y;
                          world->zone[j].room[k].door[l].other->parent->z = world->zone[j].room[k].z;
                          break;
   
                     case D_WEST:
                          world->zone[j].room[k].door[l].other->parent->x = world->zone[j].room[k].x-1;
                          world->zone[j].room[k].door[l].other->parent->y = world->zone[j].room[k].y;
                          world->zone[j].room[k].door[l].other->parent->z = world->zone[j].room[k].z;
                          break;
   
                     case D_UP:
                          world->zone[j].room[k].door[l].other->parent->x = world->zone[j].room[k].x;
                          world->zone[j].room[k].door[l].other->parent->y = world->zone[j].room[k].y-1;
                          world->zone[j].room[k].door[l].other->parent->z = world->zone[j].room[k].z+1;
                          break;
   
                     case D_DOWN:
                          world->zone[j].room[k].door[l].other->parent->x = world->zone[j].room[k].x;
                          world->zone[j].room[k].door[l].other->parent->y = world->zone[j].room[k].y+1;
                          world->zone[j].room[k].door[l].other->parent->z = world->zone[j].room[k].z-1;
                          break;
                     }
                   }
                 }
               else{
                 fprintf( stderr, "import_circle_resolve_doors:  Hanging doorway, this is bad!\n\t[%d,%d,%d]->[%d,%d,%d]\n", j, k, l, world->zone[j].room[k].door[l].czone, world->zone[j].room[k].door[l].croom, world->zone[j].room[k].door[l].cdir );
                 }
               }
            }
         }
      if( last_num_set_c == 0 &&
          num_set_c == 0 )
        break;
/*lkes:*/ last_num_set_c = num_set_c;
      num_set_c = 0;
      } while( num_set_t < total);

    return 0;
}

int import_circle_obj( WORLD *world, char *file )
{
    FILE *fh;
    char buf[80];
    int j=0, k, tmp_i;
    int zone, object;

    if( (fh = fopen( file, "rt" )) == NULL ){
      fprintf( stderr, "import_circle_obj:  Error opening file #%d, %s.\n", j, file );
      return -1;
      }

    printf("Loading from world file ``%s\'\'...\n", file );

    sscanf( get_filename( file ), "%d.obj", &tmp_i );
    if( (zone = ifind_zone_vnum_world( world, tmp_i )) < 0 ){
      zone = add_zone( world );
      world->zone[zone].vnum = tmp_i;
      }

    object = -1;
    for( k = 0;; k++ ){
       fscanf( fh, "%s\n", buf );
       switch( buf[0] ){
         case '#':  /* It's an object */
              sscanf( buf, "#%d\n", &tmp_i );
              object = add_object( &world->zone[zone] );

              world->zone[zone].object[object].vnum = tmp_i-(world->zone[zone].vnum*VNM);
  
              get_term_str( fh, world->zone[zone].object[object].keywords, '~', NAMESIZE );
              fscanf( fh, "\n");
              get_term_str( fh, world->zone[zone].object[object].short_desc, '~', NAMESIZE );
              fscanf( fh, "\n");
              get_term_str( fh, world->zone[zone].object[object].long_desc, '~', NAMESIZE );
              fscanf( fh, "\n");
              get_term_str( fh, world->zone[zone].object[object].action_desc, '~', NAMESIZE );
              fscanf( fh, "\n");
  
              fscanf( fh, "%d %s ", &world->zone[zone].object[object].type, buf );
              world->zone[zone].object[object].type--;
              world->zone[zone].object[object].ebv = scan_bv( buf );
              fscanf( fh, "%s\n", buf );
              world->zone[zone].object[object].wbv = scan_bv( buf );

              fscanf( fh, "%d %d %d %d\n", &world->zone[zone].object[object].value[0], &world->zone[zone].object[object].value[1], &world->zone[zone].object[object].value[2], &world->zone[zone].object[object].value[3] );
              fscanf( fh, "%d %d %d\n", &world->zone[zone].object[object].weight, &world->zone[zone].object[object].cost, &world->zone[zone].object[object].rpd );
              break;

         case 'A':  /* It's an affect */
              if( object < 0 ){
                fprintf( stderr, "import_circle_obj:  Affect def without object...\n");
                return -1;
                }
              tmp_i = add_object_affect( &world->zone[zone].object[object] );
              fscanf( fh, "%d %d\n", &world->zone[zone].object[object].affect[tmp_i].location, &world->zone[zone].object[object].affect[tmp_i].value );
              break;

         case 'E':  /* It's an exd */
              if( object < 0 ){
                fprintf( stderr, "import_circle_obj:  Exd def without object...\n");
                return -1;
                }
              tmp_i = add_object_exd( &world->zone[zone].object[object] );
              get_term_str( fh, world->zone[zone].object[object].exd[tmp_i].keywords, '~', NAMESIZE );
              fscanf( fh, "\n");
              get_term_str( fh, world->zone[zone].object[object].exd[tmp_i].desc, '~', RDSIZE );
              fscanf( fh, "\n");
              break;

         case '$':  /* Game over... */
              fclose( fh );
              fh = NULL;
              break;

         default:   /* Error!!! */
              fprintf( stderr, "import_circle_obj:  Expecting #, $, A, or E and got `%c\'\n", buf[0] );
              fclose( fh );
              fh = NULL;
              return -1;
              break;
         }
      if( !fh ) break;
      }
    fclose( fh );

    return j;
}

int import_circle_mob( WORLD *world, char *file )
{
    FILE *fh;
    char buf[80];
    int j=0, k, tmp_i;
    int zone, mobile;

    if( (fh = fopen( file, "rt" )) == NULL ){
      fprintf( stderr, "import_circle_mob:  Error opening file #%d, %s.\n", j, file );
      return -1;
      }

    printf("Loading from world file ``%s\'\'...\n", file );

    sscanf( get_filename( file ), "%d.mob", &tmp_i );
    if( (zone = ifind_zone_vnum_world( world, tmp_i )) < 0 ){
      zone = add_zone( world );
      world->zone[zone].vnum = tmp_i;
      }

    mobile = -1;
    for( k = 0;; k++ ){
       fscanf( fh, "%s\n", buf );
       switch( buf[0] ){
         case '#':  /* It's an object */
              sscanf( buf, "#%d\n", &tmp_i );
              mobile = add_mobile( &world->zone[zone] );

              world->zone[zone].mobile[mobile].vnum = tmp_i-(world->zone[zone].vnum*VNM);
  
              get_term_str( fh, world->zone[zone].mobile[mobile].keywords, '~', NAMESIZE );
              fscanf( fh, "\n");
              get_term_str( fh, world->zone[zone].mobile[mobile].short_desc, '~', NAMESIZE );
              fscanf( fh, "\n");
              get_term_str( fh, world->zone[zone].mobile[mobile].long_desc, '~', NAMESIZE );
              fscanf( fh, "\n");
              get_term_str( fh, world->zone[zone].mobile[mobile].detail_desc, '~', RDSIZE );
              fscanf( fh, "\n");
  
              fscanf( fh, "%s ", buf );
              world->zone[zone].mobile[mobile].actbv = scan_bv( buf );
              fscanf( fh, "%s ", buf );
              world->zone[zone].mobile[mobile].affbv = scan_bv( buf );
              fscanf( fh, "%d %c\n", &world->zone[zone].mobile[mobile].alignment, buf );

              switch( buf[0] ){
                case 'S':
                     fscanf( fh, "%d %d %d %dd%d+%d %dd%d+%d\n", &world->zone[zone].mobile[mobile].level, &world->zone[zone].mobile[mobile].thac0, &world->zone[zone].mobile[mobile].ac, &world->zone[zone].mobile[mobile].mhpx, &world->zone[zone].mobile[mobile].mhpy, &world->zone[zone].mobile[mobile].mhpz, &world->zone[zone].mobile[mobile].bhdx, &world->zone[zone].mobile[mobile].bhdy, &world->zone[zone].mobile[mobile].bhdz );
                     fscanf( fh, "%d %d\n", &world->zone[zone].mobile[mobile].gold, &world->zone[zone].mobile[mobile].exp );
                     fscanf( fh, "%d %d %d\n", &world->zone[zone].mobile[mobile].loadpos, &world->zone[zone].mobile[mobile].defpos, &tmp_i );
                     world->zone[zone].mobile[mobile].sex = (char)(tmp_i);
                     world->zone[zone].mobile[mobile].loadpos = ifind_bvitem( mob_positions, world->zone[zone].mobile[mobile].loadpos );
                     world->zone[zone].mobile[mobile].defpos = ifind_bvitem( mob_positions, world->zone[zone].mobile[mobile].defpos );
                     break;

                case 'E':
                     fscanf( fh, "%d %d %d %dd%d+%d %dd%d+%d\n", &world->zone[zone].mobile[mobile].level, &world->zone[zone].mobile[mobile].thac0, &world->zone[zone].mobile[mobile].ac, &world->zone[zone].mobile[mobile].mhpx, &world->zone[zone].mobile[mobile].mhpy, &world->zone[zone].mobile[mobile].mhpz, &world->zone[zone].mobile[mobile].bhdx, &world->zone[zone].mobile[mobile].bhdy, &world->zone[zone].mobile[mobile].bhdz );
                     fscanf( fh, "%d %d\n", &world->zone[zone].mobile[mobile].gold, &world->zone[zone].mobile[mobile].exp );
                     fscanf( fh, "%d %d %d\n", &world->zone[zone].mobile[mobile].loadpos, &world->zone[zone].mobile[mobile].defpos, &tmp_i );
                     world->zone[zone].mobile[mobile].sex = (char)(tmp_i);
                     world->zone[zone].mobile[mobile].loadpos = ifind_bvitem( mob_positions, world->zone[zone].mobile[mobile].loadpos );
                     world->zone[zone].mobile[mobile].defpos = ifind_bvitem( mob_positions, world->zone[zone].mobile[mobile].defpos );
                     for( ;; ){
                        fscanf( fh, "%s\n", buf );
                        if( buf[0] == 'E' ) break;
                        }
                     break;
                }
              break;

         case '$':  /* Game over... */
              fclose( fh );
              fh = NULL;
              break;

         default:   /* Error!!! */
              fprintf( stderr, "import_circle_mob:  Expecting #, or $ and got `%c\'\n", buf[0] );
              fclose( fh );
              fh = NULL;
              return -1;
              break;
         }
      if( !fh ) break;
      }
    fclose( fh );

    return j;
}

int import_circle_world( WORLD *world, char *prefix )
{
    FILE *fh;
    char buf[80];
    int j, numfiles;
    char thisfile[0x800];

    printf("ZoneVNUM Divider size [100/1000]:  ");
    remove_keyboard();
    scanf("%d", &VNM );
    install_keyboard();

    printf("Checking wld index...\n");

    strcpy( thisfile, prefix );
    strcat( thisfile, "wld\\index" );
    if( (fh = fopen( thisfile, "rt" )) == NULL ){
      return -1;
      }

    for( j = 0; buf[0] != '$'; j++ ){
       fscanf( fh, "%s\n", buf );
       }

    fclose( fh );

    numfiles = j-1;

    if( (fh = fopen( thisfile, "rt" )) == NULL ){
      return -1;
      }

    for( j = 0; j < numfiles; j++ ){
       fscanf( fh, "%s\n", buf );
       if( buf[0] == '$' ) break;
       strcpy( thisfile, prefix );
       strcat( thisfile, "wld\\" );
       strcat( thisfile, buf );
       import_circle_wld( world, thisfile );
       }

    fclose( fh );

    printf("Resolving doors...\n");
    import_circle_resolve_doors( world );

    printf("Checking obj index...\n");

    strcpy( thisfile, prefix );
    strcat( thisfile, "obj\\index" );
    if( (fh = fopen( thisfile, "rt" )) == NULL ){
      return -1;
      }

    for( j = 0; buf[0] != '$'; j++ ){
       fscanf( fh, "%s\n", buf );
       }

    fclose( fh );

    numfiles = j-1;

    if( (fh = fopen( thisfile, "rt" )) == NULL ){
      return -1;
      }

    for( j = 0; j < numfiles; j++ ){
       fscanf( fh, "%s\n", buf );
       if( buf[0] == '$' ) break;
       strcpy( thisfile, prefix );
       strcat( thisfile, "obj\\" );
       strcat( thisfile, buf );
       import_circle_obj( world, thisfile );
       }

    fclose( fh );

    printf("Checking mob index...\n");

    strcpy( thisfile, prefix );
    strcat( thisfile, "mob\\index" );
    if( (fh = fopen( thisfile, "rt" )) == NULL ){
      return -1;
      }

    for( j = 0; buf[0] != '$'; j++ ){
       fscanf( fh, "%s\n", buf );
       }

    fclose( fh );

    numfiles = j-1;

    if( (fh = fopen( thisfile, "rt" )) == NULL ){
      return -1;
      }

    for( j = 0; j < numfiles; j++ ){
       fscanf( fh, "%s\n", buf );
       if( buf[0] == '$' ) break;
       strcpy( thisfile, prefix );
       strcat( thisfile, "mob\\" );
       strcat( thisfile, buf );
       import_circle_mob( world, thisfile );
       }

    fclose( fh );

    return 0;
}
