#include <unistd.h>
#include <stdio.h>
#include <allegro.h>
#include "edop.h"
#include "ymw.h"
#include "gfxhelp.h"
#include "find.h"

int scrn_shot()
{
    BITMAP *bmp;
    PALETTE pal;
    char fname[14]="";
    int j;

    for( j = 0; j < 10000; j++ ){
       sprintf( fname, "shot%04d.bmp", j );
       if( !__file_exists( fname ) ){
         get_palette( pal );
         bmp = create_sub_bitmap( screen, 0, 0, SCREEN_W, SCREEN_H );
         save_bitmap( fname, bmp, pal );
         destroy_bitmap( bmp );
         return D_O_K;
         }
       }

    return D_EXIT;
}

void dotted_rect(BITMAP *bm, int x1, int y1, int x2, int y2, int fg, int bg)
{
   int x = ((x1+y1) & 1) ? 1 : 0;
   int c;

   for (c=x1; c<=x2; c++) {
      putpixel(bm, c, y1, (((c+y1) & 1) == x) ? fg : bg);
      putpixel(bm, c, y2, (((c+y2) & 1) == x) ? fg : bg);
   }

   for (c=y1+1; c<y2; c++) {
      putpixel(bm, x1, c, (((c+x1) & 1) == x) ? fg : bg);
      putpixel(bm, x2, c, (((c+x2) & 1) == x) ? fg : bg);
   }
}

void rect3d( BITMAP *db, int x1, int y1, int x2, int y2, int c1, int c2 )
{
    vline( db, x1, y1, y2, c1 );
    hline( db, x1, y1, x2, c1 );
    vline( db, x2, y1, y2, c2 );
    hline( db, x1, y2, x2, c2 );
}

void rect3dfill( BITMAP *db, int x1, int y1, int x2, int y2, int c1, int c2, int c3 )
{
    rectfill( db, x1, y1, x2, y2, c3 );
    rect3d( db, x1, y1, x2, y2, c1, c2 );
}

void room3d( BITMAP *db, int x, int y, int w, int h, int c1, int c2, int c3 )
{
    rect3dfill( db, x, y, x+w, y+h, c1, c2, c3 );
}

void draw_door( BITMAP *db,
                int x1, int y1, int d1, short typea1, short typeb1, int state1,
                int x2, int y2, int d2, short typea2, short typeb2, int state2,
                int c, int dl )
{
    int tx1=0, ty1=0, tx2=0, ty2=0, mc;

    switch( typea1 ){
      case 1:
           mc = c;
           break;

      case 2:
           mc = makecol( 255, 0, 0 );
           break;

      default:
           mc = c;
      }

    switch( d1 ){
      case D_NORTH:
           tx1 = x1;
           ty1 = y1-RR-DSL;
           line( db, x1, y1-RR-1, tx1, ty1, c );
           if( typeb1 & D_CANT_LEAVE ){
             triangle( db,
                       x1,   y1-RR-1,
                       x1+3, y1-RR-4,
                       x1-3, y1-RR-4,
                       c );
             }
           else{
             if( typea1 == 1 ||
                 typea1 == 2 ){
               line( db, x1-RR, y1-RR*2, x1+RR, y1-RR*2, mc );
               if( state1 == 1 ){
                 line( db, x1-RR+1, y1-RR*2, x1-RR+1, y1-RR-1, mc );
                 line( db, x1+RR-1, y1-RR*2, x1+RR-1, y1-RR-1, mc );
                 }
               else if( state1 == 2 ){
                 rectfill( db, x1-RR+1, y1-RR*2, x1+RR-1, y1-RR-1, mc );
                 }
               }
             }
           break;

      case D_EAST:
           tx1 = x1+RR+DSL+1;
           ty1 = y1;
           line( db, x1+RR+2, y1, tx1, ty1, c );
           if( typeb1 & D_CANT_LEAVE ){
             triangle( db,
                       x1+RR+1, y1,
                       x1+RR+4, y1+3,
                       x1+RR+4, y1-3,
                       c );
             }
           else{
             if( typea1 == 1 ||
                 typea1 == 2 ){
               line( db, x1+RR*2+1, y1-RR, x1+RR*2+1, y1+RR, mc );
               if( state1 == 1 ){
                 line( db, x1+RR+2, y1+RR-1, x1+RR*2+1, y1+RR-1, mc );
                 line( db, x1+RR+2, y1-RR+1, x1+RR*2+1, y1-RR+1, mc );
                 }
               else if( state1 == 2 ){
                 rectfill( db, x1+RR+2, y1+RR-1, x1+RR*2+1, y1-RR+1, mc );
                 }
               }
             }
           break;

      case D_SOUTH:
           tx1 = x1;
           ty1 = y1+RR+DSL+1;
           line( db, x1, y1+RR+2, tx1, ty1, c );
           if( typeb1 & D_CANT_LEAVE ){
             triangle( db,
                       x1,   y1+RR+1,
                       x1-3, y1+RR+4,
                       x1+3, y1+RR+4,
                       c );
             }
           else{
             if( typea1 == 1 ||
                 typea1 == 2 ){
               line( db, x1-RR, y1+RR*2+1, x1+RR, y1+RR*2+1, mc );
               if( state1 == 1 ){
                 line( db, x1-RR+1, y1+RR*2, x1-RR+1, y1+RR+2, mc );
                 line( db, x1+RR-1, y1+RR*2, x1+RR-1, y1+RR+2, mc );
                 }
               else if( state1 == 2 ){
                 rectfill( db, x1-RR+1, y1+RR*2, x1+RR-1, y1+RR+2, mc );
                 }
               }
             }
           break;

      case D_WEST:
           tx1 = x1-RR-DSL;
           ty1 = y1;
           line( db, x1-RR-1, y1, tx1, ty1, c );
           if( typeb1 & D_CANT_LEAVE ){
             triangle( db,
                       x1-RR-1, y1,
                       x1-RR-4, y1+3,
                       x1-RR-4, y1-3,
                       c );
             }
           else{
             if( typea1 == 1 ||
                 typea1 == 2 ){
               line( db, x1-RR*2, y1-RR, x1-RR*2, y1+RR, mc );
               if( state1 == 1 ){
                 line( db, x1-RR-1, y1+RR-1, x1-RR*2, y1+RR-1, mc );
                 line( db, x1-RR-1, y1-RR+1, x1-RR*2, y1-RR+1, mc );
                 }
               else if( state1 == 2 ){
                 rectfill( db, x1-RR-1, y1+RR-1, x1-RR*2, y1-RR+1, mc );
                 }
               }
             }
           break;

      case D_UP:
           tx1 = x1-RR-3;
           ty1 = y1-RR-1;
           if( !(typeb1 & D_CANT_LEAVE) ){
             triangle( db,
                       x1-RR-1, y1-1,
                       x1-RR-5, y1-1,
                       x1-RR-3, y1-RR,
                       c );
             }
           break;

      case D_DOWN:
           tx1 = x1-RR-3;
           ty1 = y1+RR+1;
           if( !(typeb1 & D_CANT_LEAVE) ){
             triangle( db,
                       x1-RR-5, y1+1,
                       x1-RR-1, y1+1,
                       x1-RR-3, y1+RR,
                       c );
             }
           break;
      }

    switch( typea2 ){
      case 1:
           mc = c;
           break;

      case 2:
           mc = makecol( 255, 0, 0 );
           break;

      default:
           mc = c;
           break;
      }

    switch( d2 ){
      case D_NORTH:
           tx2 = x2;
           ty2 = y2-RR-DSL;
           line( db, x2, y2-RR-1, tx2, ty2, c );
           if( typeb2 & D_CANT_LEAVE ){
             triangle( db,
                       x2,   y2-RR-1,
                       x2+3, y2-RR-4,
                       x2-3, y2-RR-4,
                       c );
             }
           else{
             if( typea2 == 1 ||
                 typea2 == 2 ){
               line( db, x2-RR, y2-RR*2, x2+RR, y2-RR*2, mc );
               if( state2 == 1 ){
                 line( db, x2-RR+1, y2-RR*2, x2-RR+1, y2-RR-1, mc );
                 line( db, x2+RR-1, y2-RR*2, x2+RR-1, y2-RR-1, mc );
                 }
               else if( state2 == 2 ){
                 rectfill( db, x2-RR+1, y2-RR*2, x2+RR-1, y2-RR-1, mc );
                 }
               }
             }
           break;

      case D_EAST:
           tx2 = x2+RR+DSL+1;
           ty2 = y2;
           line( db, x2+RR+2, y2, tx2, ty2, c );
           if( typeb2 & D_CANT_LEAVE ){
             triangle( db,
                       x2+RR+1, y2,
                       x2+RR+4, y2+3,
                       x2+RR+4, y2-3,
                       c );
             }
           else{
             if( typea2 == 1 ||
                 typea2 == 2 ){
               line( db, x2+RR*2+1, y2-RR, x2+RR*2+1, y2+RR, mc );
               if( state2 == 1 ){
                 line( db, x2+RR+2, y2+RR-1, x2+RR*2+1, y2+RR-1, mc );
                 line( db, x2+RR+2, y2-RR+1, x2+RR*2+1, y2-RR+1, mc );
                 }
               else if( state2 == 2 ){
                 rectfill( db, x2+RR+2, y2+RR-1, x2+RR*2+1, y2-RR+1, mc );
                 }
               }
             }
           break;

      case D_SOUTH:
           tx2 = x2;
           ty2 = y2+RR+DSL+1;
           line( db, x2, y2+RR+2, tx2, ty2, c );
           if( typeb2 & D_CANT_LEAVE ){
             triangle( db,
                       x2,   y2+RR+1,
                       x2-3, y2+RR+4,
                       x2+3, y2+RR+4,
                       c );
             }
           else{
             if( typea2 == 1 ||
                 typea2 == 2 ){
               line( db, x2-RR, y2+RR*2+1, x2+RR, y2+RR*2+1, mc );
               if( state2 == 1 ){
                 line( db, x2-RR+1, y2+RR*2, x2-RR+1, y2+RR+2, mc );
                 line( db, x2+RR-1, y2+RR*2, x2+RR-1, y2+RR+2, mc );
                 }
               else if( state2 == 2 ){
                 rectfill( db, x2-RR+1, y2+RR*2, x2+RR-1, y2+RR+2, mc );
                 }
               }
             }
           break;

      case D_WEST:
           tx2 = x2-RR-DSL;
           ty2 = y2;
           line( db, x2-RR-1, y2, tx2, ty2, c );
           if( typeb2 & D_CANT_LEAVE ){
             triangle( db,
                       x2-RR-1, y2,
                       x2-RR-4, y2+3,
                       x2-RR-4, y2-3,
                       c );
             }
           else{
             if( typea2 == 1 ||
                 typea2 == 2 ){
               line( db, x2-RR*2, y2-RR, x2-RR*2, y2+RR, mc );
               if( state2 == 1 ){
                 line( db, x2-RR-1, y2+RR-1, x2-RR*2, y2+RR-1, mc );
                 line( db, x2-RR-1, y2-RR+1, x2-RR*2, y2-RR+1, mc );
                 }
               else if( state2 == 2 ){
                 rectfill( db, x2-RR-1, y2+RR-1, x2-RR*2, y2-RR+1, mc );
                 }
               }
             }
           break;

      case D_UP:
           tx2 = x2-RR-3;
           ty2 = y2-RR-1;
           if( !(typeb2 & D_CANT_LEAVE) ){
             triangle( db,
                       x2-RR-1, y2-1,
                       x2-RR-5, y2-1,
                       x2-RR-3, y2-RR,
                       c );
             }
           break;

      case D_DOWN:
           tx2 = x2-RR-3;
           ty2 = y2+RR+1;
           if( !(typeb2 & D_CANT_LEAVE) ){
             triangle( db,
                       x2-RR-5, y2+1,
                       x2-RR-1, y2+1,
                       x2-RR-3, y2+RR,
                       c );
             }
           break;
      }

    if( dl )
      line( db, tx1, ty1, tx2, ty2, c );
}

void set_colors( DIALOG *d )
{
    int j;
    int clr[3]={ makecol( 150, 175, 150 ),
                 makecol( 175, 190, 175 ),
                 makecol( 20,  15,  20  ) };

    if( d ){
      for( j = 0; d[j].proc != NULL; j++ ){
         if( d[j].fg > -1 && d[j].fg < 3 )
           d[j].fg = clr[d[j].fg];
         else
           d[j].fg = makecol( 255, 0, 0 );
  
         if( d[j].bg > -1 && d[j].bg < 3 )
           d[j].bg = clr[d[j].bg];
         else
           d[j].bg = makecol( 255, 0, 0 );
         }
      }

    gui_fg_color = clr[CTX];
    gui_bg_color = clr[CFG];
}

int stcols[10];

void set_stcol( int index, int color )
{
    stcols[index] = color;
}

int get_stcol( int index )
{
    return stcols[index];
}

void draw_map( WORLD *world, BITMAP *db, int ox, int oy, int layer,
               int mode, void *ex1, void *ex2, unsigned short opt )
{
    int j, k, l, dl=TRUE, tx=0, ty=0;
    int *selbox = NULL;
    MSEL *msel = NULL;
    int zone_sel = -1, room_sel = -1;

    switch( mode ){
      case DMODE_SINGLE:
           zone_sel = (int)(ex1);
           room_sel = (int)(ex2);
           break;

      case DMODE_MSELPICK:
           selbox = ex1;
           msel = ex2;
           break;

      case DMODE_MSEL:
           msel = ex2;
           break;
      }

    text_mode( -1 );
    for( j = -db->w/GS/2-1; j < db->w/GS/2+2; j++ ){
       vline( db, db->w/2+j*GS+ox%GS, 0, db->h, makecol( 200, 215, 200 ) );
       }

    for( j = -db->h/GS/2-1; j < db->h/GS/2+2; j++ ){
       hline( db, 0, db->h/2+j*GS+oy%GS, db->w, makecol( 200, 215, 200 ) );
       }

    for( j = -db->w/GS/2-1; j < db->w/GS/2+2; j++ ){
       if( ox/GS-j == 0 )
         vline( db, db->w/2+j*GS+ox%GS, 0, db->h, makecol( 200, 85, 80 ) );
       if( (ox/GS-j)%5 == 0 )
         textprintf_centre( db, font, (db->w/2+j*GS+ox%GS)+1, db->h-text_height(font)-1, makecol( 100, 107, 100 ), "%d", -(ox/GS-j) );
       }

    for( j = -db->h/GS/2-1; j < db->h/GS/2+2; j++ ){
       if( oy/GS-j == 0 )
         hline( db, 0, db->h/2+j*GS+oy%GS, db->w, makecol( 200, 85, 80 ) );
       if( (oy/GS-j)%5 == 0 )
         textprintf( db, font, 1, db->h/2+j*GS+oy%GS-(text_height(font)/2)+1, makecol( 100, 107, 100 ), "%d", (oy/GS-j) );
       }
    textprintf_right( db, font, db->w-1, 1, makecol( 100, 107, 100 ), "Layer %d", layer );

    for( j = 0; j < world->num_zones; j++ ){
       if( opt & DRAW_1ZONE && j != zone_sel )
         continue;
       for( k = 0; k < world->zone[j].num_rooms; k++ ){
          if( world->zone[j].room[k].z == layer-1 ){
            rectfill( db, db->w/2+ox+(world->zone[j].room[k].x*GS)-RR+OLOS, db->h/2+oy+(world->zone[j].room[k].y*GS)-RR+OLOS, db->w/2+ox+(world->zone[j].room[k].x*GS)-RR+RR*2+1+OLOS, db->h/2+oy+(world->zone[j].room[k].y*GS)-RR+RR*2+1+OLOS, makecol( 50, 150, 196 ) );

            for( l = 0; l < world->zone[j].room[k].num_doors; l++ ){
               if( !world->zone[j].room[k].door[l].other )
                 continue;
               if( world->zone[j].room[k].z == world->zone[j].room[k].door[l].other->parent->z ){
                 draw_door( db,
                            db->w/2+ox+(world->zone[j].room[k].x*GS)+OLOS,
                            db->h/2+oy+(world->zone[j].room[k].y*GS)+OLOS,
                            world->zone[j].room[k].door[l].dir,
                            world->zone[j].room[k].door[l].typea,
                            world->zone[j].room[k].door[l].typeb,
                            world->zone[j].room[k].door[l].state,
                            db->w/2+ox+(world->zone[j].room[k].door[l].other->parent->x*GS)+OLOS,
                            db->h/2+oy+(world->zone[j].room[k].door[l].other->parent->y*GS)+OLOS,
                            world->zone[j].room[k].door[l].other->dir,
                            world->zone[j].room[k].door[l].other->typea,
                            world->zone[j].room[k].door[l].other->typeb,
                            world->zone[j].room[k].door[l].other->state,
                            makecol( 50, 150, 196 ),
                            dl
                            );
                 }
               }
            }
          }
       for( k = 0; k < world->zone[j].num_rooms; k++ ){
          if( world->zone[j].room[k].z == layer ){
            if( opt & DRAW_COASTERS ){
              if( opt & DRAW_TRANS ){
                drawing_mode( DRAW_MODE_TRANS, NULL, 0, 0 );
                rectfill( db, db->w/2+ox+(world->zone[j].room[k].x*GS)-(GS/2-1), db->h/2+oy+(world->zone[j].room[k].y*GS)-(GS/2-1), db->w/2+ox+(world->zone[j].room[k].x*GS)+(GS/2), db->h/2+oy+(world->zone[j].room[k].y*GS)+(GS/2), stcols[world->zone[j].room[k].stype] );
                drawing_mode( DRAW_MODE_SOLID, NULL, 0, 0 );
                }
              else{
                rectfill( db, db->w/2+ox+(world->zone[j].room[k].x*GS)-(GS/2-1), db->h/2+oy+(world->zone[j].room[k].y*GS)-(GS/2-1), db->w/2+ox+(world->zone[j].room[k].x*GS)+(GS/2), db->h/2+oy+(world->zone[j].room[k].y*GS)+(GS/2), stcols[world->zone[j].room[k].stype] );
                }
              }

            if( msel ){
              if( find_msel_item( msel, j, k ) ){
                room3d( db, db->w/2+ox+(world->zone[j].room[k].x*GS)-RR, db->h/2+oy+(world->zone[j].room[k].y*GS)-RR, RR*2+1, RR*2+1, makecol( 255, 255, 255 ), makecol( 115, 115, 115 ), world->zone[j].tint^0xffffffff );
                if( world->zone[j].room[k].num_cont )
                  line( db, db->w/2+ox+(world->zone[j].room[k].x*GS)-RR, db->h/2+oy+(world->zone[j].room[k].y*GS)-RR, db->w/2+ox+(world->zone[j].room[k].x*GS)-RR+RR*2+1, db->h/2+oy+(world->zone[j].room[k].y*GS)-RR+RR*2+1, world->zone[j].tint );
                }
              else{
                room3d( db, db->w/2+ox+(world->zone[j].room[k].x*GS)-RR, db->h/2+oy+(world->zone[j].room[k].y*GS)-RR, RR*2+1, RR*2+1, makecol( 255, 255, 255 ), makecol( 115, 115, 115 ), world->zone[j].tint );
                if( world->zone[j].room[k].num_cont )
                  line( db, db->w/2+ox+(world->zone[j].room[k].x*GS)-RR, db->h/2+oy+(world->zone[j].room[k].y*GS)-RR, db->w/2+ox+(world->zone[j].room[k].x*GS)-RR+RR*2+1, db->h/2+oy+(world->zone[j].room[k].y*GS)-RR+RR*2+1, world->zone[j].tint^0xffffffff );
                }
              }
            else{
              if( zone_sel == j && room_sel == k ){
                room3d( db, db->w/2+ox+(world->zone[j].room[k].x*GS)-RR, db->h/2+oy+(world->zone[j].room[k].y*GS)-RR, RR*2+1, RR*2+1, makecol( 255, 255, 255 ), makecol( 115, 115, 115 ), world->zone[j].tint^0xffffffff );
                if( world->zone[j].room[k].num_cont )
                  line( db, db->w/2+ox+(world->zone[j].room[k].x*GS)-RR, db->h/2+oy+(world->zone[j].room[k].y*GS)-RR, db->w/2+ox+(world->zone[j].room[k].x*GS)-RR+RR*2+1, db->h/2+oy+(world->zone[j].room[k].y*GS)-RR+RR*2+1, world->zone[j].tint );
                }
              else{
                room3d( db, db->w/2+ox+(world->zone[j].room[k].x*GS)-RR, db->h/2+oy+(world->zone[j].room[k].y*GS)-RR, RR*2+1, RR*2+1, makecol( 255, 255, 255 ), makecol( 115, 115, 115 ), world->zone[j].tint );
                if( world->zone[j].room[k].num_cont )
                  line( db, db->w/2+ox+(world->zone[j].room[k].x*GS)-RR, db->h/2+oy+(world->zone[j].room[k].y*GS)-RR, db->w/2+ox+(world->zone[j].room[k].x*GS)-RR+RR*2+1, db->h/2+oy+(world->zone[j].room[k].y*GS)-RR+RR*2+1, world->zone[j].tint^0xffffffff );
                }
              }

            for( l = 0; l < world->zone[j].room[k].num_doors; l++ ){
               if( !world->zone[j].room[k].door[l].other )
                 continue;
               if( world->zone[j].room[k].z == world->zone[j].room[k].door[l].other->parent->z ){
                 dl = TRUE;
                 tx = db->w/2+ox+(world->zone[j].room[k].door[l].other->parent->x*GS);
                 ty = db->h/2+oy+(world->zone[j].room[k].door[l].other->parent->y*GS);
                 }
               else{
                 if( world->zone[j].room[k].z == world->zone[j].room[k].door[l].other->parent->z+1 ){
                   tx = db->w/2+ox+(world->zone[j].room[k].door[l].other->parent->x*GS)+OLOS;
                   ty = db->h/2+oy+(world->zone[j].room[k].door[l].other->parent->y*GS)+OLOS;
                   dl = TRUE;
                   }
                 else if( world->zone[j].room[k].z == world->zone[j].room[k].door[l].other->parent->z-1 ){
                   tx = db->w/2+ox+(world->zone[j].room[k].door[l].other->parent->x*GS)-OLOS;
                   ty = db->h/2+oy+(world->zone[j].room[k].door[l].other->parent->y*GS)-OLOS;
                   dl = TRUE;
                   }
                 else{
                   dl = FALSE;
                   }
                 }
               draw_door( db,
                          db->w/2+ox+(world->zone[j].room[k].x*GS),
                          db->h/2+oy+(world->zone[j].room[k].y*GS),
                          world->zone[j].room[k].door[l].dir,
                          world->zone[j].room[k].door[l].typea,
                          world->zone[j].room[k].door[l].typeb,
                          world->zone[j].room[k].door[l].state,
                          tx,
                          ty,
                          world->zone[j].room[k].door[l].other->dir,
                          world->zone[j].room[k].door[l].other->typea,
                          world->zone[j].room[k].door[l].other->typeb,
                          world->zone[j].room[k].door[l].other->state,
                          0,
                          dl
                          );
               }
            }
          }
       for( k = 0; k < world->zone[j].num_rooms; k++ ){
          if( world->zone[j].room[k].z == layer+1 ){
            rect( db, db->w/2+ox+(world->zone[j].room[k].x*GS)-RR-OLOS, db->h/2+oy+(world->zone[j].room[k].y*GS)-RR-OLOS, db->w/2+ox+(world->zone[j].room[k].x*GS)-RR+RR*2+1-OLOS, db->h/2+oy+(world->zone[j].room[k].y*GS)-RR+RR*2+1-OLOS, makecol( 230, 230, 230 ) );

            for( l = 0; l < world->zone[j].room[k].num_doors; l++ ){
               if( !world->zone[j].room[k].door[l].other )
                 continue;
               if( world->zone[j].room[k].z == world->zone[j].room[k].door[l].other->parent->z ){
                 draw_door( db,
                            db->w/2+ox+(world->zone[j].room[k].x*GS)-OLOS,
                            db->h/2+oy+(world->zone[j].room[k].y*GS)-OLOS,
                            world->zone[j].room[k].door[l].dir,
                            world->zone[j].room[k].door[l].typea,
                            world->zone[j].room[k].door[l].typeb,
                            world->zone[j].room[k].door[l].state,
                            db->w/2+ox+(world->zone[j].room[k].door[l].other->parent->x*GS)-OLOS,
                            db->h/2+oy+(world->zone[j].room[k].door[l].other->parent->y*GS)-OLOS,
                            world->zone[j].room[k].door[l].other->dir,
                            world->zone[j].room[k].door[l].other->typea,
                            world->zone[j].room[k].door[l].other->typeb,
                            world->zone[j].room[k].door[l].other->state,
                            makecol( 230, 230, 230 ),
                            dl
                            );
                 }
               }
            }
          }
       if( opt & DRAW_TAGS ){
         if( opt & DRAW_TRANS )
           drawing_mode( DRAW_MODE_TRANS, NULL, 0, 0 );
         for( k = 0; k < world->zone[j].num_tags; k++ ){
            if( world->zone[j].tag[k].z != layer )
              continue;
            world->zone[j].tag[k].w = text_length( font, world->zone[j].tag[k].str );
            world->zone[j].tag[k].h = text_height( font );
            rectfill( db,
                      db->w/2+ox+(world->zone[j].tag[k].x*GS)-(world->zone[j].tag[k].w/2)-2,
                      db->h/2+oy+(world->zone[j].tag[k].y*GS)-(world->zone[j].tag[k].h/2)-2,
                      db->w/2+ox+(world->zone[j].tag[k].x*GS)+(world->zone[j].tag[k].w/2)+2,
                      db->h/2+oy+(world->zone[j].tag[k].y*GS)+(world->zone[j].tag[k].h/2)+2,
                      world->zone[j].tint
                      );
            rect( db,
                  db->w/2+ox+(world->zone[j].tag[k].x*GS)-(world->zone[j].tag[k].w/2)-2,
                  db->h/2+oy+(world->zone[j].tag[k].y*GS)-(world->zone[j].tag[k].h/2)-2,
                  db->w/2+ox+(world->zone[j].tag[k].x*GS)+(world->zone[j].tag[k].w/2)+2,
                  db->h/2+oy+(world->zone[j].tag[k].y*GS)+(world->zone[j].tag[k].h/2)+2,
                  0
                  );
            text_mode( -1 );
            textout_centre( db,
                            font,
                            world->zone[j].tag[k].str,
                            db->w/2+ox+(world->zone[j].tag[k].x*GS),
                            db->h/2+oy+(world->zone[j].tag[k].y*GS)-(world->zone[j].tag[k].h/2),
                            0xffffffff^world->zone[j].tint
                            );
            }
         if( opt & DRAW_TRANS )
           drawing_mode( DRAW_MODE_SOLID, NULL, 0, 0 );
         }
       }

    if( selbox ){
      rect( db,
            db->w/2+ox+selbox[0],
            db->h/2+oy+selbox[1],
            db->w/2+ox+selbox[2],
            db->h/2+oy+selbox[3],
            makecol( 45, 75, 250 )
            );
      }
}

